<?php

  require_once("settings.php");
  require_once('functions.php');

  if (file_exists($set["install_lockfile_path"])) {
      returnMsg("Error: The program has been installed.");
  }

  $action = isset($_POST["action"]) ? $_POST["action"] : '';
  $messageReturn = "Error: The parameter is incorrect.";

  if (empty($action) || !in_array($action, array("connectMySQL", "connectSQLite", "startInstall", "makeConfig", "importSQL"))) {
      returnMsg($messageReturn);
  }

  switch ($action) {
      case "connectMySQL":
          connectMySQL();
          break;
      case "startInstall":
          startInstall();
          break;
      default:
          returnMsg($messageReturn);
  }

  function connectMySQL() {
      global $set;
      $mysql_host = $_POST["mysql_host"];
      $mysql_port = $_POST["mysql_port"];
      $mysql_db_name = $_POST["mysql_db_name"];
      $mysql_username = $_POST["mysql_username"];
      $mysql_password = $_POST["mysql_password"];

      if (empty($mysql_host)) {
          returnMsg("Error: MySQL Host Address field is required.");
      }
      if (empty($mysql_db_name)) {
          returnMsg("Error: Database Name field is required.");
      }
      if (empty($mysql_username)) {
          returnMsg("Error: Database Account field is required.");
      }

      $conn = null;
      //import sql
      if ($mysql_port) {
          $connect_string = $mysql_host . ":" . $mysql_port;
      } else {
          $connect_string = $mysql_host;
      }

      $conn = mysql_connect($connect_string, $mysql_username, $mysql_password);

      $result = "";

      if ($conn) {
          if (mysql_select_db($mysql_db_name, $conn)) {
              $result = "Database connected successfully.";
          } else {
              $result = "Error: Unable to select databese.";
          }
      } else {
          $result = "Error: Unable to not connect database.";
      }
      @mysql_close($conn);
      returnMsg($result);
  }

  function startInstall() {
      global $set;
      $db_type = $_POST["db_type"];
      $mysql_host = $_POST["mysql_host"];
      $mysql_port = $_POST["mysql_port"];
      $mysql_db_name = $_POST["mysql_db_name"];
      $mysql_table_prefix = $_POST["mysql_table_prefix"];
      $mysql_username = $_POST["mysql_username"];
      $mysql_password = $_POST["mysql_password"];

      $admin_username = $_POST["admin_username"];
      $admin_password = md5(trim($_POST["admin_password"]));
      $admin_email = $_POST["email"];
      $website = $_POST["website"];
      $installation_path = $_POST["installation_path"];

      if (substr($website, -1) != "/") {
          $website .= "/";
      }

      if (substr($installation_path, -1) != "/") {
          $installation_path .= "/";
      }

      $messageReturn = "";

      if ($db_type == "mysql") {

          $fp = fopen($set["mysql_dump"], "r");
          $sql_str = fread($fp, filesize($set["mysql_dump"]));
          fclose($fp);

          $sql_str = str_replace($set["admin_username_tag"], $admin_username, $sql_str);
          $sql_str = str_replace($set["admin_password_tag"], $admin_password, $sql_str);
          $sql_str = str_replace($set["admin_email_tag"], $admin_email, $sql_str);
          $sql_str = str_replace($set["admin_website_tag"], $website, $sql_str);
          $sql_str = str_replace($set["admin_installation_path"], $installation_path, $sql_str);

          $sql_str = str_replace('[TB_PREFIX]', $mysql_table_prefix, $sql_str);
          $sqls = explode("\n", $sql_str);

          //import sql
          if ($mysql_port) {
              $connect_string = $mysql_host . ":" . $mysql_port;
          } else {
              $connect_string = $mysql_host;
          }

          $link = @mysql_connect($connect_string, $mysql_username, $mysql_password) or die("Error: Could not connect. ");
          @mysql_select_db($mysql_db_name, $link) or die("Error: Could not use: " . $mysql_db_name);

          foreach ($sqls as $sql) {
              if (strlen($sql) > 10) {
                  mysql_query($sql, $link);
              }
          }

          mysql_close($link);
          $messageReturn .= "Database has been imported sucessfully.<br />";
      }

      //create config file

      $content = file_get_contents("./" . $set["config_file_template"]);
      $content = str_replace("[MYSQLHOST]", $mysql_host, $content);
      $content = str_replace("[DBNAME]", $mysql_db_name, $content);
      $content = str_replace("[DBUSER]", $mysql_username, $content);
      $content = str_replace("[DBPASS]", $mysql_password, $content);
      $content = str_replace("[DBPREFIX]", $mysql_table_prefix, $content);
      file_put_contents($set["config_file_path"], $content);

      $messageReturn .= "Create " . $set["config_file_path"] . " successfully.<br />";

      //copy files
      foreach ($set["copy_dirs"] as $dir) {
          $data_file_list = glob("./data/" . $dir . "/*.*");

          foreach ($data_file_list as $file) {
              $full_file = "../" . $dir . "/" . basename($file);
              copy($file, $full_file);
          }
      }

      // create index.php file
      if (file_exists('../index.html')) {
          rename('../index.html', "../index.removed.html");
      }
      if (file_exists('../index.noinstall.php')) {
          rename('../index.noinstall.php', "../index.php");
      }

      // create installed lock file.
      $handle = fopen($set["install_lockfile_path"], 'w');
      fwrite($handle, 'A iKode Product');
      fclose($handle);

      $messageReturn .= "Create " . $set["install_lockfile_path"] . " sucessfully.";

      returnMsg($messageReturn);
  }

// return info
  function returnMsg($msg) {
      exit($msg);
  }

?>