$(document).ready(function(){
       
    $("#captcha").click(function(){
        resetCaptcha();
    });    

    $("#sign").submit(function(){
       
        var options = {
            beforeSubmit : checkSign,
            dataType : "json",
            type : "post",
            success: function(responseText){
                hideWaiting();
                $("#notification").show();
				
                if(responseText.msg.indexOf('Error:') == -1){
                    $("#notification").addClass("success"); 
                    $("#notification").html(responseText.msg);
                    window.location.href = "./index.php?c=frontTicket&m=signedLite";
                }
                else{
                    $("#notification").addClass("error"); 
                    $("#notification").html(responseText.msg);
                }
            }
        };
        $(this).ajaxSubmit(options);
        return false;
    });

    if($("#popupwin").length > 0){
        load_fancybox($("#popupwin"));
    }
  
});


function clickIpt(obj){
    if($(obj).length == 0){
        return true;
    }
    $(obj).css("border-color","#CDCDCD");
    return true;
}

function checkSign(){    
    var c_first_name = true;
    if($("#first_name").is(":visible")){
        c_first_name = checkObjBlank("#first_name");
    }
    var c_email = checkObjBlank("#email");
    var c_subject = checkObjBlank("#subject");
    var c_message = checkObjBlank("#message");

    var c_vcode = true;
    if($('#vcode').length > 0){
        c_vcode = checkObjBlank("#vcode");
    }

    if(c_first_name && c_email  && c_subject && c_message && c_vcode){
        if( checkObjEmail("#email") == false){
            $("#notification").html("Not a valid email address");
            return false;
        }
        if($("#first_name").is(":visible")){
            if(checkObjLen("#first_name", 3) == false){
                $("#notification").html("Your name length can be no less than 3");
                return false;
            }
        }

        if(checkObjLen("#email", 5) == false){
            $("#notification").html("Your email address length can be no less than 5");
            return false;
        }

        if(checkObjLen("#subject", 5) == false){
            $("#notification").html("Subject length can can be no less than 5");
            return false;
        }

        if(checkObjLen("#message", 5) == false){
            $("#notification").html("Message length can be no less than 20");
            return false;
        }

        showWaiting()
        return true;
    }else{
        $("#notification").html(required_error);
        return false;
    }
}

function checkObjBlank(obj){
    if($(obj).length == 0){
        return true;
    }
    if($(obj).val() == ''){
        $(obj).css("border-color","red");
        return false;
    }
    else{
        $(obj).css("border-color","#CDCDCD");
        return true;
    }
}

function checkObjLen(obj, minLen){
    if($(obj).val().length < minLen){
        $(obj).css("border-color","red");
        return false;
    }
    else{
        $(obj).css("border-color","#CDCDCD");
        return true;
    }
}

function checkObjEmail(obj){
    if($(obj).val().search(/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) != -1){
        $(obj).css("border-color","#CDCDCD");
        return true;
    }
    else{
        $(obj).css("border-color","red");
        return false;
    }
}

function showWaiting(){
    $('#waiting-box').css("display", "inline");
}

function hideWaiting(){
    $('#waiting-box').css("display", "none");
}

function resetCaptcha(){
    if($('#captcha').length > 0){
        $("#captcha").attr('src', './index.php?c=utility&m=createCaptcha&r=' + Math.round(Math.random() * 10000));
    }
}

function checkCustomer(email){
    if(email.search(/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) == -1){
        return false;
    }
    $.ajax({
        url : "index.php?c=frontTicket&m=checkCustomer",
        type : "get",
        dataType : "text",
        data:{
            "email":email
        },
        success:function(data){
            if( data == "+OK"){
                $("#more-information").hide("fast");
            }else{
                $("#more-information").show("fast");
            }
        }
    })
    
    return false;
}

function load_fancybox(obj){
    obj.fancybox({
        'width':470,
        'height':500,
        'padding':10,
        'margin':0,
        'scrolling':'auto',
        'autoDimensions':false,
        'autoScale': true,
        'transitionIn': 'none',
        'transitionOut': 'none',
        'type': 'iframe'
    });
}